//Leons Petrazickis
//Dual Europe Events Generator
//Uses St Leo's Civ++ Event Engine V1.0

#include<fstream.h>

//Triggers
void citytaken(char city[255],
			   char attacker[255],
			   char defender[255]);
void negotiation(char talker[255],
				 char talkertype[255],
				 char listener[255],
				 char listenertype[255]);
void randomturn(int denominator);
void scenarioloaded();
void turn(int turn);
void unitkilled(char unit[255],
				char attacker[255],
				char defender[255]);

//Actions
void createunit(char owner[255],
				char unit[255],
				char veteran[255],
				char homecity[255],
				char loc[255]);
void justonce();
void noschism(char defender[255]);
void playwavefile(char filename[255]);
void text(char text[32000]);

//Keywords
void beginevents();
void endevents();
void IF();
void THEN();
void ENDIF();
void debug();

//Mostly mnemonic in value
char civs[8][256] = {
		"Humans",
		"Azracs",
		"Orcs",
		"Elves",
		"Hobbits",
		"Saurs",
		"Dwarves",
		"Barbarians"};


ofstream fout("events.txt");		//creates a variable of type ofstream

void main(){
	//Scenario-specific variables
	char answer = ' ';			//Answer to prompts
	int x=0;					//Index for loops
	int leaderfreq = 5;			//Probability for a leader
	int mincreatfreq = 2;		//Probability for a small creature
	int medcreatfreq = 3;		//Probability for a large creature
	int maxcreatfreq = 7;		//Probability for a giant creature
	int startupmultiplier = 3; //How many duplicate units to create on the first turn

	char madridloc[]	= "9,37";
	char parisloc[]		= "21,23";
	char londonloc[]	= "17,17";
	char wienloc[]		= "42,24";
	char veniceloc[]	= "38,28";

	char azracloc[]		= "92,48";
	char orcloc[]		= "94,40";
	char elfloc[]		= "96,16";
	char hobloc[]		= "89,11";
	char saurloc[]		= "58,42";
	char dwarfloc[]		= "70,2";

	cout << "Welcome to the Setup Program for Dual Europe.\n";
	cout << "\t-Answer in lowercase and follow up with an [Enter]\n";
	cout << "\t-Run it again whenever you start a new game\n";
	cout << "\t-If it summons aliens from Alpha Centauri, it is not my fault\n\n";

	beginevents();
	//debug();

	IF();
	noschism("ANYBODY");
	THEN();
	ENDIF();

	cout << "\nAre Azracs being played by a human? (y|n)";
	cin >> answer;

	IF();
	randomturn(leaderfreq);
	THEN();
	text("An Azrac lord has taken up arms against the human invaders");
	createunit("Azracs","Azrac Lord",	"no","NONE",azracloc);
	ENDIF();

	if (answer == 'y' || answer == 'Y'){
	}
	else{
		for(x=0;x<startupmultiplier;x++){
			IF();
			randomturn(mincreatfreq);
			THEN();
			createunit("Azracs","Sandworm",		"no","NONE",azracloc);
			ENDIF();
		}
	}

	cout << "\nAre Orcs being played by a human? (y|n)";
	cin >> answer;

	IF();
	randomturn(leaderfreq);
	THEN();
	text("An Orcish Lord has grown tired of bashing goblin skulls and is taking up the bashing of human skulls.");
	createunit("Orcs","Orc Lord",	"no","NONE",orcloc);
	ENDIF();

	if (answer == 'y' || answer == 'Y'){
	}
	else{		
		for(x=0;x<startupmultiplier;x++){
			IF();
			randomturn(medcreatfreq);
			THEN();
			createunit("Orcs","Troll",		"no","NONE",orcloc);
			ENDIF();
		}
	}

	cout << "\nAre Elves being played by a human? (y|n)";
	cin >> answer;

	IF();
	randomturn(leaderfreq);
	THEN();
	text("An Elven princeling is read to give all in the defense of his homeland");
	createunit("Elves","Elven Prince",	"no","NONE",elfloc);
	ENDIF();

	if (answer == 'y' || answer == 'Y'){
	}
	else{		
		for(x=0;x<startupmultiplier;x++){
			IF();
			randomturn(maxcreatfreq);
			THEN();
			createunit("Elves","Fairy Dragon", "no","NONE",elfloc);
			ENDIF();
			IF();
			randomturn(medcreatfreq);
			THEN();
			createunit("Elves","Dendroid", "no","NONE",elfloc);
			ENDIF();
		}
	}

	cout << "\nAre Hobbits being played by a human? (y|n)";
	cin >> answer;

	IF();
	randomturn(leaderfreq);
	THEN();
	text("A Hobbit Lord in the manner of the old times is about to display his race's hidden ferocity.");
	createunit("Hobbits","Hobbit Lord",	"no","NONE",hobloc);
	ENDIF();

	if (answer == 'y' || answer == 'Y'){
	}
	else{		
		for(x=0;x<startupmultiplier;x++){			
			IF();
			randomturn(maxcreatfreq);
			THEN();
			createunit("Hobbits","Titan",		"no","NONE",hobloc);
			ENDIF();			
			IF();
			randomturn(medcreatfreq);
			THEN();
			createunit("Hobbits","Eagle Rider",		"no","NONE",hobloc);
			ENDIF();
		}
	}

	cout << "\nAre Saurs being played by a human? (y|n)";
	cin >> answer;

	IF();
	randomturn(leaderfreq);
	THEN();
	text("A Saur Basilisk feels like munching on some human flesh.");
	createunit("Saurs","Basilisk",	"no","NONE",saurloc);
	ENDIF();

	if (answer == 'y' || answer == 'Y'){
	}
	else{		
		for(x=0;x<startupmultiplier;x++){			
			IF();
			randomturn(medcreatfreq);
			THEN();
			createunit("Saurs","Turtle Catapult",		"no","NONE",saurloc);
			ENDIF();
			
			IF();
			randomturn(maxcreatfreq);
			THEN();
			createunit("Saurs","Sea Serpent",		"no","NONE",saurloc);
			ENDIF();
			
			IF();
			randomturn(maxcreatfreq);
			THEN();
			createunit("Saurs","Frog Rider",		"no","NONE",saurloc);
			ENDIF();
		}
	}

	cout << "\nAre Dwarves being played by a human? (y|n)";
	cin >> answer;

	IF();
	randomturn(leaderfreq);
	THEN();
	text("A Dwarven Lord needs to blunt his overly-sharp battleaxe with human necks.");
	createunit("Dwarves","Dwarven Lord",	"no","NONE",dwarfloc);
	ENDIF();

	if (answer == 'y' || answer == 'Y'){
	}
	else{		
		for(x=0;x<startupmultiplier;x++){			
			IF();
			randomturn(maxcreatfreq);
			THEN();
			createunit("Dwarves","Ancient One",	"no","NONE",dwarfloc);
			text("A Dwarven Ancient One has been woken by careless humans and needs to release some pent-up wrath.");
			ENDIF();
			
			IF();
			randomturn(medcreatfreq);
			THEN();
			createunit("Dwarves","Behemoth", "no","NONE",dwarfloc);
			ENDIF();
		}
	}

	IF();
	turn(10);
	THEN();
	text("Austrians have proclaimed a crusade to retake humandom's losses");
	createunit("Humans","German Knights", "no", "NONE", wienloc);
	ENDIF();
	IF();
	randomturn(10);
	THEN();
	createunit("Humans","German Knights", "no", "NONE", wienloc);
	ENDIF();
	IF();
	randomturn(10);
	THEN();
	createunit("Humans","German Knights", "no", "NONE", wienloc);
	ENDIF();
	IF();
	randomturn(10);
	THEN();
	createunit("Humans","German Knights", "no", "NONE", wienloc);
	ENDIF();
	IF();
	randomturn(10);
	THEN();
	createunit("Humans","German Knights", "no", "NONE", wienloc);
	ENDIF();

	IF();
	unitkilled("German Knights","anybody","humans");
	THEN();
	text("A Crusade is being organised in France");
	justonce();
	ENDIF();
	IF();
	unitkilled("German Knights","Azracs","humans");
	THEN();
	createunit("Humans","French Knights","no","NONE",parisloc);
	ENDIF();
	IF();
	unitkilled("German Knights","Orcs","humans");
	THEN();
	createunit("Humans","French Knights","no","NONE",parisloc);
	ENDIF();
	IF();
	unitkilled("German Knights","Elves","humans");
	THEN();
	createunit("Humans","French Knights","no","NONE",parisloc);
	ENDIF();
	IF();
	unitkilled("German Knights","Hobbits","humans");
	THEN();
	createunit("Humans","French Knights","no","NONE",parisloc);
	ENDIF();
	IF();
	unitkilled("German Knights","Saurs","humans");
	THEN();
	createunit("Humans","French Knights","no","NONE",parisloc);
	ENDIF();
	IF();
	unitkilled("German Knights","Dwarves","humans");
	THEN();
	createunit("Humans","French Knights","no","NONE",parisloc);
	ENDIF();

	IF();
	unitkilled("French Knights","anybody","humans");
	THEN();
	text("A Crusade is being organised in England");
	justonce();
	ENDIF();
	IF();
	unitkilled("French Knights","Azracs","humans");
	THEN();
	createunit("Humans","English Knights","no","NONE",londonloc);
	ENDIF();
	IF();
	unitkilled("French Knights","Orcs","humans");
	THEN();
	createunit("Humans","English Knights","no","NONE",londonloc);
	ENDIF();
	IF();
	unitkilled("French Knights","Elves","humans");
	THEN();
	createunit("Humans","English Knights","no","NONE",londonloc);
	ENDIF();
	IF();
	unitkilled("French Knights","Hobbits","humans");
	THEN();
	createunit("Humans","English Knights","no","NONE",londonloc);
	ENDIF();
	IF();
	unitkilled("French Knights","Saurs","humans");
	THEN();
	createunit("Humans","English Knights","no","NONE",londonloc);
	ENDIF();
	IF();
	unitkilled("French Knights","Dwarves","humans");
	THEN();
	createunit("Humans","English Knights","no","NONE",londonloc);
	ENDIF();
	
	IF();
	unitkilled("English Knights","anybody","humans");
	THEN();
	text("Berbers are reinforcing Italy");
	justonce();
	ENDIF();
	IF();
	unitkilled("English Knights","Azracs","humans");
	THEN();
	createunit("Humans","Berber Raiders","no","NONE",veniceloc);
	ENDIF();
	IF();
	unitkilled("English Knights","Orcs","humans");
	THEN();
	createunit("Humans","Berber Raiders","no","NONE",veniceloc);
	ENDIF();
	IF();
	unitkilled("English Knights","Elves","humans");
	THEN();
	createunit("Humans","Berber Raiders","no","NONE",veniceloc);
	ENDIF();
	IF();
	unitkilled("English Knights","Hobbits","humans");
	THEN();
	createunit("Humans","Berber Raiders","no","NONE",veniceloc);
	ENDIF();
	IF();
	unitkilled("English Knights","Saurs","humans");
	THEN();
	createunit("Humans","Berber Raiders","no","NONE",veniceloc);
	ENDIF();
	IF();
	unitkilled("English Knights","Dwarves","humans");
	THEN();
	createunit("Humans","Berber Raiders","no","NONE",veniceloc);
	ENDIF();

	for(x=0; x<2; x++){
		IF();
		randomturn(mincreatfreq);
		THEN();
		createunit("Humans","Knights","No","NONE",madridloc);
		ENDIF();
	}

	IF();
	unitkilled("Basilisk","Humans","Saurs");
	THEN();
	text("A Basilisk has held a blinking contest with Death and lost");
	ENDIF();
	IF();
	unitkilled("Orc Lord","Humans","Orcs");
	THEN();
	text("An Orcish Lord has fallen");
	ENDIF();
	IF();
	unitkilled("Hobbit Lord","Humans","Hobbits");
	THEN();
	text("A Hobbit Lord has died grasping his sling");
	ENDIF();
	IF();
	unitkilled("Azrac Lord","Humans","Azracs");
	THEN();
	text("An Azrac Lord was slain after his sacred knife broke.");
	ENDIF();
	IF();
	unitkilled("Dwarven Lord","Humans","Dwarves");
	THEN();
	text("A Dwarven Lord has hewed his last neck");
	ENDIF();
	IF();
	unitkilled("Elven Prince","Humans","Elves");
	THEN();
	text("As his bowstring broke, an Elven Prince's life string was cut by the Norns");
	ENDIF();

	IF();
	citytaken("Vienna","anybody","Humans");
	THEN();
	text("Vienna, home of the German Emperors, has fallen to the eldritch hordes");
	ENDIF();
	IF();
	citytaken("Paris","anybody","Humans");
	THEN();
	text("Paris, capital of the booming France, has fallen to the eldritch hordes");
	ENDIF();
	IF();
	citytaken("London","anybody","Humans");
	THEN();
	text("London, the backwater of Europe, has fallen to the eldritch hordes");
	ENDIF();
	IF();
	citytaken("Madrid","anybody","Humans");
	THEN();
	text("Madrid, the other backwater of Europe, has fallen to the eldritch hordes");
	ENDIF();
	
	IF();
	negotiation("humans","HUMANORCOMPUTER","ANYBODY","HUMANORCOMPUTER");
	THEN();
	ENDIF();	
	IF();
	negotiation("anybody","HUMANORCOMPUTER","humans","HUMANORCOMPUTER");
	THEN();
	ENDIF();

	endevents();
	fout.close();
}

void createunit(char owner[255],
				char unit[255],
				char veteran[255],
				char homecity[255],
				char loc[255]){
	fout << "CreateUnit\n";
	fout << "owner=" << owner << "\n";
	fout << "unit=" << unit << "\n";
	fout << "veteran=" << veteran << "\n";
	fout << "homecity=" << homecity << "\n";
	fout << "locations\n" << loc << "\nendlocations\n";
}

void unitkilled(char unit[255],
				char attacker[255],
				char defender[255]){
	fout << "UnitKilled\n";
	fout << "unit=" << unit << "\n";
	fout << "attacker=" << attacker << "\n";
	fout << "defender=" << defender << "\n";
}

void randomturn(int denominator){
	fout << "RandomTurn\n";
	fout << "denominator=" << denominator << "\n";
}

void turn(int turn){
	fout << "Turn\n";
	fout << "turn=" << turn << "\n";
}

void negotiation(char talker[255],
				 char talkertype[255],
				 char listener[255],
				 char listenertype[255]){
    fout << "Negotiation\n";
    fout << "talker=" << talker << "\n";
    fout << "talkertype="<< talkertype << "\n";
    fout << "listener="<< listener << "\n";
    fout << "listenertype="<< listenertype << "\n";
}

void text(char text[32000]){
	fout << "Text\n";
	fout << text << "\n";
	fout << "EndText\n";
}


void beginevents(){
	fout << "@BEGINEVENTS\n";
}

void endevents(){
	fout << "@ENDEVENTS\n";
}

void IF(){
	fout << "@IF\n";
}

void THEN(){
	fout << "@THEN\n";
}

void ENDIF(){
	fout << "@ENDIF\n";
}

void justonce(){
	fout << "JustOnce\n";
}

void noschism(char defender[255]){
	fout << "NoSchism\n";
	fout << "defender=" << defender << "\n";
}

void citytaken(char city[255],
			   char attacker[255],
			   char defender[255]){
	fout << "CityTaken\n";
	fout << "city=" << city << "\n";
	fout << "attacker=" << attacker << "\n";
	fout << "defender=" << defender << "\n";
}

void playwavefile(char filename[255]){
	fout << "PlayWaveFile\n";
	fout << filename << "\n";
}

void scenarioloaded(){
	fout << "ScenarioLoaded\n";
}

void debug(){
	fout << "@DEBUG\n";
}